- [HTTP request](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.customFields/list#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.customFields/list#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.customFields/list#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.customFields/list#body.request_body)
- [Response body](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.customFields/list#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.customFields/list#body.ListCustomFieldsResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.customFields/list#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.customFields/list#body.aspect_1)

**Full name**: projects.locations.instances.customFields.list

Lists configured CustomFields. Use this method to discover the current set of custom fields configured for this instance. Supports filtering by display name and field type.

### HTTP request

`GET https://{endpoint}/v1alpha/{parent}/customFields`

Where `{endpoint}` is one of the [supported service endpoints](https://docs.cloud.google.com/chronicle/docs/reference/rest#rest_endpoints).

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. The parent instance for which to list CustomFields. Format: projects/{project}/locations/{location}/instances/{instance} |

### Query parameters

| Parameters ||
|---|---|
| `pageSize` | `integer` Optional. The maximum number of CustomFields to return. The service may return fewer than this value. If unspecified, at most 50 CustomFields will be returned. The maximum value is 1000; values above 1000 will be coerced to 1000. |
| `pageToken` | `string` Optional. A page token, received from a previous `customFields.list` call. Provide this to retrieve the subsequent page. When paginating, all other parameters provided to `customFields.list` must match the call that provided the page token. |
| `filter` | `string` Optional. Filter to be applied over multiple CustomField fields. Example: `filter="displayName='My Field' AND type='FREE_TEXT'"` Supported filter fields: \* `displayName` \* `type` \* `scopes` (using `HAS` operator, e.g., `scopes:ALERT`) |
| `orderBy` | `string` Optional. Configures ordering of CustomFields in the response. The orderBy string is a comma separated list of fields. The default ordering is by `name` ascending. Supported orderBy fields: \* `name` \* `displayName` \* `type` Example: `orderBy="displayName desc, name asc"` |

### Request body

The request body must be empty.

### Response body

Response message for customFields.list.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "customFields": [ { object (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.customFields#CustomField`) } ], "nextPageToken": string, "totalSize": integer } ``` |

| Fields ||
|---|---|
| `customFields[]` | ``object (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.customFields#CustomField`)`` The list of CustomFields. |
| `nextPageToken` | `string` A token, which can be sent as `pageToken` to retrieve the next page. If this field is omitted, there are no subsequent pages. |
| `totalSize` | `integer` The total number of CustomFields matching the request criteria, disregarding pagination. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `
  https://www.googleapis.com/auth/chronicle`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permission on the `parent` resource:

- `chronicle.customFields.get`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).